--[[
[b]1 January 2019[/b] v1.1
- Fixed a bug where "coins" reward selection would occasionally give mods, and "mods" reward selection would occasionally give coins. Oopsie woopsie, I made a fuckie wuckie.
- Fixed bad "menu_ok" localization

--]]
CoinsForPackages = CoinsForPackages or {}
CoinsForPackages._save_path = SavePath .. "coinsforpackages.txt"
CoinsForPackages._stored_path = SavePath .. "coinsforpackages_queued.txt"
CoinsForPackages._path = ModPath
CoinsForPackages.settings = {
	payment_mode = 1,
	store_rewards = false
}
CoinsForPackages.quickmenu_items = {}

CoinsForPackages.queued = {}

function CoinsForPackages:GetAutoStorageEnabled()
	return self.settings.store_rewards
end

function CoinsForPackages:AddReward(assignment)
	assignment = tostring(assignment)
	self.queued[assignment] = self.queued[assignment] or 0
	self.queued[tostring(assignment)] = self.queued[tostring(assignment)] + 1
	self:SaveQueued()
end

function CoinsForPackages:GetPaymentMode()
	return self.settings.payment_mode
end

function CoinsForPackages:RedeemReward(assignment,from_queued)
	local td = tweak_data.gage_assignment.assignments[assignment]
	local a = td.aquire
	local assignment_name = managers.localization:text(td.name_id)
	local function show_gage_message(is_coin)
		local text
		local roll = math.random()
		if is_coin then
			if roll > 0.99 then 
				text = managers.localization:text("coinsforpackages_message_coin_shitpost")
			else
			--[[
			--i was gonna add this for ~lore flavor~ but i decided that I didn't want people actually visiting random IPs across the webz.
				local address = ""
				if roll > 0.66 then 
					address = address .. "192.168." + math.random(255) + "." + math.random(255)
				elseif roll > 0.33 then 
					address = address .."172." + (16 + math.random(15)) + "." + math.random(255) + "." + math.random(255)			
				else
					address = address .."10." + math.random(255) + "." + math.random(255) + "." + math.random(255)
				end
				--]]	
				text = managers.localization:text("coinsforpackages_message_coin_standard")
			end
		else
			if roll > 0.99 then 
				text = managers.localization:text("coinsforpackages_message_mods_shitpost")
			else
				text = managers.localization:text("coinsforpackages_message_mods_standard")
			end
		end
		
		--apply macros
		text = string.gsub(text,"$YEAR",os.date("%Y"))
		text = string.gsub(text,"$ASSIGNMENT",assignment_name)
		text = string.gsub(text,"$COINS",a)
		
		
		local title = managers.localization:text("coinsforpackages_message_title")
		local desc = managers.localization:text("coinsforpackages_message_desc")
		desc = string.gsub(desc,"$DATE",os.date("%c"))
		desc = string.gsub(desc,"$MESSAGE",text)
		QuickMenu:new(title,desc,{
			{
				text = managers.localization:text("dialog_ok"),
				is_cancel_button = true
			}
		
		},true)
	end
	local function pay_in_coins(skip_confirm)
		if not skip_confirm then 
			show_gage_message(true)
		end
		if self.queued[assignment] and (self.queued[assignment] > 0) then 
			managers.custom_safehouse:add_coins(a)
			self.queued[assignment] = self.queued[assignment] - 1
			self:SaveQueued()
			return
		end
	end
	local function pay_in_mods(skip_confirm)
		if not skip_confirm then 
			show_gage_message(false)
		end
		if self.queued[assignment] and (self.queued[assignment] > 0) then
			self.orig_give_rewards(managers.gage_assignment,assignment)
			self.queued[assignment] = self.queued[assignment] - 1
			self:SaveQueued()
			return
		end
	end

	local payment_mode = CoinsForPackages:GetPaymentMode()
	if payment_mode == 1 then 
		return pay_in_coins(not from_queued)
	elseif payment_mode == 2 then
		return pay_in_mods(not from_queued)
	elseif payment_mode == 3 then
		local reward_string
		for i,reward in ipairs(managers.gage_assignment._tweak_data:get_value(assignment,"rewards")) do
			if reward_string then 
				reward_string = reward_string .. "\n"
			else
				reward_string = "[" .. string.upper(managers.localization:text("coinsforpackages_present_mods")) .. "]\n"
			end
			local reward_source,reward_type,reward_item = unpack(reward)
			if reward_type == "weapon_mods" then
				local part = tweak_data.weapon.factory.parts[tostring(reward_item)]
				reward_string = reward_string .. "+ " .. managers.localization:text(part and part.name_id or reward_item)
				
			else
				--probably only happens if you have other mods that change gage rewards
				reward_string = reward_string .. "ERROR: unknown reward type (" .. tostring(reward_type) .. ") for reward (" .. tostring(reward_item) .. ")"
			end
		end
 		reward_string = reward_string .. "\n" .. managers.localization:text("coinsforpackages_alternative_divider") .. "\n[" .. string.upper(managers.localization:text("coinsforpackages_present_coins")) .. "]\n+ " .. tostring(a) .. " " .. managers.localization:text("coinsforpackages_payment_mode_coins")
		QuickMenu:new(managers.localization:text(td.present_id),reward_string,{
			{
				text = managers.localization:text("coinsforpackages_present_mods"),
				callback = pay_in_mods
			},
			{
				text = managers.localization:text("coinsforpackages_present_coins"),
				callback = pay_in_coins
			},
			--[[ this was meant to add a button to stop the avalanche of queued reward prompts if you want to go do something else instead of redeem packages all day.
			--yeah i gotta either make done callbacks for each one and queue them, or go through system dialog manager to find and remove the queued quickmenu item.
			{
				text = managers.localization:text("coinsforpackages_present_stop")
			,
				callback = function()
					for i,m in ipairs(CoinsForPackages.quickmenu_items) do 
						if m then
							m:hide()
						end
						table.remove(CoinsForPackages.quickmenu_items,i)
					end
				end
			},
			--]]
			{
				text = managers.localization:text("coinsforpackages_present_stall"),
				is_cancel_button = true
			}
		
		},true)
	end
end

function CoinsForPackages:ConfirmStartRedeeming()
	local amount_string
	local has_any = false
	
	
	for assignment,num in pairs(self.queued) do 
		local td = tweak_data.gage_assignment.assignments[assignment]
		if td then 
			has_any = true
			if amount_string then 
				amount_string = amount_string .. "\n"
			else
				amount_string = ""
			end
			local assignment_name = managers.localization:text(td.name_id)
			
			local reward = managers.localization:text("coinsforpackages_list_rewards")
			reward = string.gsub(reward,"$AMOUNT",num)
			reward = string.gsub(reward,"$ASSIGNMENT",assignment_name)
			amount_string = amount_string .. reward
		end
	end
	
	if has_any then 
		QuickMenu:new(managers.localization:text("coinsforpackages_confirm_start_redeem"),amount_string,{
			{
				text = managers.localization:text("dialog_yes"),
				callback = callback(self,self,"RedeemQueued")
			},
			{
				text = managers.localization:text("dialog_no"),
				is_cancel_button = true
			}
		},true)
	else
		QuickMenu:new(managers.localization:text("coinsforpackages_no_stored_rewards_title"),managers.localization:text("coinsforpackages_no_stored_rewards_desc"),{
			{
				text = managers.localization:text("dialog_ok"),
				is_cancel_button = true
			}			
		},true)
	end
end

function CoinsForPackages:RedeemQueued()
	local done_any = false
	for assignment,num in pairs(self.queued) do 
		for i = 1,num do 
			self:RedeemReward(assignment,true)
			done_any = true
		end
	end
	if not done_any then
		QuickMenu:new(managers.localization:text("coinsforpackages_no_stored_found_title"),managers.localization:text("coinsforpackages_no_stored_found_desc"),{
			{
				text = managers.localization:text("dialog_ok"),
				is_cancel_button = true
			}
		},true)
	else
		self:SaveQueued()	
	end
	
end

function CoinsForPackages:SaveQueued()
	for assignment,num in pairs(self.queued) do 
		if tweak_data.gage_assignment.assignments[assignment] and num <= 0 then 
			self.queued[assignment] = nil
		end
	end
	local file = io.open(self._stored_path,"w+")
	if file then
		file:write(json.encode(self.queued))
		file:close()
	end
end

function CoinsForPackages:LoadQueued()
	local file = io.open(self._stored_path, "r")
	if (file) then
		for k, v in pairs(json.decode(file:read("*all"))) do
			self.queued[k] = v
		end
	else
		self:SaveQueued()
	end
end

function CoinsForPackages:Load()
	local file = io.open(self._save_path, "r")
	if (file) then
		for k, v in pairs(json.decode(file:read("*all"))) do
			self.settings[k] = v
		end
	else
		self:Save()
	end
	return self.settings
end

function CoinsForPackages:Save()
	local file = io.open(self._save_path,"w+")
	if file then
		file:write(json.encode(self.settings))
		file:close()
	end
end

Hooks:Add("LocalizationManagerPostInit", "CoinsForPackages_LocalizationManagerPostInit", function( loc )
	for _, filename in pairs(file.GetFiles(CoinsForPackages._path .. "loc/")) do
		local str = filename:match('^(.*).txt$')
		if str and Idstring(str) and Idstring(str):key() == SystemInfo:language():key() then
			loc:load_localization_file(CoinsForPackages._path .. "loc/" .. filename)
			return
		end
	end
	loc:load_localization_file( CoinsForPackages._path .. "loc/english.txt")
end)

Hooks:Add("MenuManagerInitialize", "CoinsForPackages_MenuManagerInitialize", function(menu_manager)

	MenuCallbackHandler.callback_coinsforpackages_payment_mode = function(self,item)
		CoinsForPackages.settings.payment_mode = tonumber(item:value())
		CoinsForPackages:Save()
	end
	
	MenuCallbackHandler.callback_coinsforpackages_store_rewards = function(self,item)
		CoinsForPackages.settings.store_rewards = item:value() == "on"
		CoinsForPackages:Save()
	end
	
	MenuCallbackHandler.callback_coinsforpackages_redeem_queued = function(self)
		CoinsForPackages:ConfirmStartRedeeming()
	end
	
	--close
	MenuCallbackHandler.callback_coinsforpackages_close = function(this)
--		CoinsForPackages:Save()
	end

	CoinsForPackages:Load()
	CoinsForPackages:LoadQueued()
	
	MenuHelper:LoadFromJsonFile(CoinsForPackages._path .. "menu/options.txt", CoinsForPackages, CoinsForPackages.settings)		
end)